//Chargement de la librairie WS2812 Adafruit
#include <Adafruit_NeoPixel.h>

//Define Pin
int pinbtnfunction = 2;
int pinbtncolor = 3;
int pinledindicator = 4;
#define PIXEL_PIN  6 

//Define valeur Buton Default
volatile int statefunction = LOW;
volatile int statecolor = LOW;

//Definition de variable de fontionnement par default
int showType = 0;
int showcolor = 0;
int colorR = 0;
int colorG = 0;
int colorB = 255;


#define PIXEL_COUNT 150

//Initialisation de la librairie WS2812 Adafruit
Adafruit_NeoPixel strip = Adafruit_NeoPixel(PIXEL_COUNT, PIXEL_PIN, NEO_GRB + NEO_KHZ800);

//SETUP
void setup() {
    Serial.begin(9600);
    pinMode(pinbtnfunction, OUTPUT);
    pinMode(pinbtncolor, OUTPUT);
    pinMode(pinledindicator, OUTPUT);
    attachInterrupt(digitalPinToInterrupt(pinbtnfunction), blink, CHANGE  );
    attachInterrupt(digitalPinToInterrupt(pinbtncolor), blink2, CHANGE  );


    //LED
    strip.begin();
    strip.show(); // Initialize all pixels to 'off'
    strip.setBrightness(100);
    //DEMARAGE DU SHOW
    startShow(showType);
}


//LOOP
void loop() {
  

}

//InteruptionFunction
void blink() {
    statefunction = !statefunction;
}


//InteruptionColor
void blink2() {
    statecolor = !statecolor;
}

//changeemnt de fonction
void changefunction(){
  showType++;
  if (showType > 10){
    showType=0;
  }    
  Serial.println("Change Function");
  startShow(showType);
}

//Changement de couleur
void changecolor(){
  showcolor++;
  if (showcolor > 7){
    showcolor=0;
  } 
  Serial.println("Change Color");
  changeColor(showcolor);
}



//Start nouvelle couleur
void changeColor(int i) {
    switch(i){
      case 0: delay(500);
              colorR = 255;
              colorG = 255;
              colorB = 255;
              delay(100);
              //REDEMARAGE DU SHOW
              startShow(showType);
              break;
     case 1:  delay(500);
              colorR = 255;
              colorG = 0;
              colorB = 0;
              delay(100);
              //REDEMARAGE DU SHOW
              startShow(showType);
              break;
     case 2:  delay(500);
              colorR = 0;
              colorG = 255;
              colorB = 0;
              delay(100);
              //REDEMARAGE DU SHOW
              startShow(showType);
              break;
     case 3: delay(500);
              colorR = 0;
              colorG = 0;
              colorB = 255;
              delay(100);
              //REDEMARAGE DU SHOW
              startShow(showType);
              break;
     case 4:  delay(500);
              colorR = 255;
              colorG = 0;
              colorB = 255;
              delay(100);
              //REDEMARAGE DU SHOW
              startShow(showType);
              break;
     case 5:  delay(500);
              colorR = 219;
              colorG = 0;
              colorB = 115;
              delay(100);
              //REDEMARAGE DU SHOW
              startShow(showType);
              break;
     case 6:  delay(500);
              colorR = 84;
              colorG = 249;
              colorB = 141;
              delay(100);
              //REDEMARAGE DU SHOW
              startShow(showType);
              break;
     case 7:  delay(500);
              colorR = 255;
              colorG = 255;
              colorB = 0;
              delay(100);
              //REDEMARAGE DU SHOW
              startShow(showType);
              break;
              
 }
}

//Start Show
void startShow(int i) {
    switch(i){
      case 0: strip.show();
              infoprogrammation(i);
              delay(500);
              colorWipe(1);    // Rouge
              break;
     case 1: strip.show();
              infoprogrammation(i);
              delay(500);
              colorWipeandWhite(10);    // Vert
              break;
     case 2: strip.show();
              infoprogrammation(i);
              delay(500);
              colorWipeWater(10);    // Vert
              break;
     case 3: strip.show();
              infoprogrammation(i);
              delay(500);
              theaterChase(10);    // Vert
              break;
     case 4: strip.show();
              infoprogrammation(i);
              delay(500);
              randomPositionFill(10);    // Vert
              break;
     case 5: strip.show();
              infoprogrammation(i);
              delay(500);
              middleFill(10);    // Vert
              break;
     case 6: strip.show();
              infoprogrammation(i);
              delay(500);
              sideFill(10);    // Vert
              break;
     case 7: strip.show();
              infoprogrammation(i);
              delay(500);
              rainbow(10);    // Vert
              break;
     case 8: strip.show();
              infoprogrammation(i);
              delay(500);
              rainbowCycle(10);    // Vert
              break;
     case 9: strip.show();
              infoprogrammation(i);
              delay(500);
              theaterChaseRainbow(10);    // Vert
              break;
     case 10: strip.show();
              infoprogrammation(i);
              delay(500);
              alternateColor(100);    // Vert
              break;
              
 }
}

// Fill the dots one after the other with a color
void infoprogrammation(int i) {
  
    for(uint16_t f=0; f<=i; f++) {
      delay(300);
      digitalWrite(pinledindicator, HIGH);
      delay(100);
      digitalWrite(pinledindicator, LOW);
      delay(100); 
    }

  }

void resetbtn(){
  statefunction = LOW;
  statecolor = LOW;
  delay(100);
}

void colorWipe(uint8_t wait) {
resetbtn();
    for(uint16_t i=0; i<strip.numPixels(); i++) {
        if(statefunction == HIGH){
          changefunction();
        }else if(statecolor == HIGH){
          changecolor();
        }else{
        strip.setPixelColor(i, strip.Color(colorR, colorG, colorB));
        strip.show();
        delay(wait);
        
       }
      }
      while(1){
          if(statefunction == HIGH){
          changefunction();
        }else if(statecolor == HIGH){
          changecolor();
        }
    }
  }

void colorWipeoff(uint8_t wait) {
resetbtn();
    for(uint16_t i=0; i<strip.numPixels(); i++) {
        if(statefunction == HIGH){
          changefunction();
        }else if(statecolor == HIGH){
          changecolor();
        }else{
        strip.setPixelColor(i, strip.Color(0, 0, 0));
        strip.show();
        delay(wait);
        }
    }
  }


// Fill the dots one after the other with a color
void colorWipeandWhite(uint8_t wait) {
resetbtn();
    while(1){
    for(uint16_t i=0; i<strip.numPixels(); i++) {
        if(statefunction == HIGH){
          changefunction();
        }else if(statecolor == HIGH){
          changecolor();
        }else{
        strip.setPixelColor(i, strip.Color(255, 255, 255));
        strip.show();
        delay(wait);
        }
    }
    for(uint16_t i=0; i<strip.numPixels(); i++) {
        if(statefunction == HIGH){
          changefunction();
        }else if(statecolor == HIGH){
          changecolor();
        }else{
        strip.setPixelColor(i, strip.Color(colorR, colorG, colorB));
        strip.show();
        delay(wait);
        }
    }
  }
}

void colorWipeWater(uint8_t wait) {
resetbtn();
  uint8_t lenghtwater = 2;
      for(uint16_t i=0; i<strip.numPixels(); i++) {
          if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
          strip.setPixelColor(i, strip.Color(colorR, colorG, colorB));
          strip.show();
          delay(wait);
      
    }
  
  while(1){
    
    lenghtwater = lenghtwater+1;
      for(uint16_t v=0; v<strip.numPixels(); v++) {
        
          uint32_t color = strip.getPixelColor(v);
            
             for(uint16_t f=0; f<lenghtwater; f++) {
              if(statefunction == HIGH){
                  changefunction();
                }else if(statecolor == HIGH){
                  changecolor();
                }else{
                strip.setPixelColor(v+f, strip.Color(255, 255, 255));
                strip.show(); 
               }
             }
             strip.setPixelColor(v,strip.Color(colorR, colorG, colorB));
             strip.setPixelColor(v+1, strip.Color(colorR, colorG, colorB));
             strip.show();
             delay(10*(v/6));
             
              
      }
     // Reset si lengh water est egal a 10
     if(lenghtwater == 10) {lenghtwater = 2;}  
    }
  }
}


void theaterChase(uint8_t wait) {
resetbtn();
  while(1){
    for (int j=0; j<1; j++) {  //do 10 cycles of chasing
      for (int q=0; q < 3; q++) {
        for (int i=0; i < strip.numPixels(); i=i+3) {
          if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
          strip.setPixelColor(i+q, strip.Color(colorR, colorG, colorB));    //turn every third pixel on
           }
        }
        strip.show();
       
        delay(wait);
       
        for (int i=0; i < strip.numPixels(); i=i+3) {
          if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
              strip.setPixelColor(i+q, 0);        //turn every third pixel off
            }
        }
      }
    }
  }
}

void randomPositionFill( uint8_t wait) {
resetbtn();
  while(1){

    int used[strip.numPixels()]; // array to keep track of lit LEDs
    int lights = 0; // counter
  
    for(int i = 0; i<strip.numPixels(); i++){ // fill array with 0
      if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
            used[i] = 0;
            }
    }
  
    while(lights<strip.numPixels()-1) {
       if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
            int j = random(0,strip.numPixels()-1); // pick a random LED
            if(used[j] != 1){ // if LED not already lit, proceed
              strip.setPixelColor(j, strip.Color(colorR, colorG, colorB));
              used[j] = 1; // update array to remember it is lit
              lights++;
              strip.show(); // display
              delay(wait);
            }
      }
    }
  colorWipeoff(10);  // OFF
  }
}

void middleFill(uint8_t wait) {
resetbtn();
  while(1){
    for(uint16_t i=0; i<(strip.numPixels()/2); i++) { // start from the middle, lighting an LED on each side
      if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
              strip.setPixelColor(strip.numPixels()/2 + i, strip.Color(colorR, colorG, colorB));
              strip.setPixelColor(strip.numPixels()/2 - i, strip.Color(colorR, colorG, colorB));
              strip.show();
            }
      delay(wait);
    }
  
    for(uint16_t i=0; i<(strip.numPixels()/2); i++) { // reverse
      if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
            strip.setPixelColor(i, strip.Color(0, 0, 0));
            strip.setPixelColor(strip.numPixels() - i, strip.Color(0, 0, 0));
            strip.show();
            delay(wait);
            }
    }
  }
}

void sideFill(uint8_t wait) {
resetbtn();
  while(1){
    for(uint16_t i=0; i<(strip.numPixels()/2); i++) { // fill strip from sides to middle
       if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
            strip.setPixelColor(i,strip.Color(colorR, colorG, colorB));
            strip.setPixelColor(strip.numPixels() - i,strip.Color(colorR, colorG, colorB));
            strip.show();
            delay(wait);
            }
    }
  
    for(uint16_t i=0; i<(strip.numPixels()/2); i++) { // reverse
        if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
            strip.setPixelColor(strip.numPixels()/2 + i, strip.Color(0, 0, 0));
            strip.setPixelColor(strip.numPixels()/2 - i, strip.Color(0, 0, 0));
            strip.show();
            delay(wait);
            }
    }
  }
}

void rainbow(uint8_t wait) {
resetbtn();
  uint16_t i, j;
  while(1){
    for(j=0; j<256; j++) {
      for(i=0; i<strip.numPixels(); i++) {
        if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
            strip.setPixelColor(i, Wheel((i+j) & 255));
            }
      }
      strip.show();
      delay(wait);
    }
  }
}

void rainbowCycle(uint8_t wait) {
resetbtn();
  uint16_t i, j;
   while(1){
    for(j=0; j<256; j++) { 
      for(i=0; i< strip.numPixels(); i++) {
        if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
            strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
            }
      }
      strip.show();
      delay(wait);
    }
   }
}

void theaterChaseRainbow(uint8_t wait) {
resetbtn();
  while(1){
    for (int j=0; j < 256; j++) {     // cycle all 256 colors in the wheel
      for (int q=0; q < 3; q++) {
          for (int i=0; i < strip.numPixels(); i=i+3) {
            if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
            strip.setPixelColor(i+q, Wheel( (i+j) % 255));    //turn every third pixel on
            }
          }
          strip.show();
         
          delay(wait);
         
          for (int i=0; i < strip.numPixels(); i=i+3) {
            if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
            strip.setPixelColor(i+q, 0);        //turn every third pixel off
            }
          }
      }
    }
  }
}

void alternateColor(uint8_t wait) {
resetbtn();
  while(1){
    for(uint16_t i=0; i<strip.numPixels(); i++) {
      if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{ 
              if(i%2 == 0) { // set even LED to color 1
                strip.setPixelColor(i, strip.Color(colorR, colorG, colorB));
              } else { // set odd LED to color 2
                strip.setPixelColor(i, strip.Color(255, 255, 255));
              }
            }
    }
  
    strip.show(); // apply the colors
    delay(wait);
  
    for(uint16_t i=0; i<strip.numPixels(); i++) {
      if(statefunction == HIGH){
              changefunction();
            }else if(statecolor == HIGH){
              changecolor();
            }else{
              if(i%2 == 0) { // set even LED to color 2
                strip.setPixelColor(i, strip.Color(255, 255, 255));
              } else { // set odd LED to color 1
                strip.setPixelColor(i, strip.Color(colorR, colorG, colorB));
              }
            }
    }
  
    strip.show(); // apply the colors
    delay(wait);
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
   return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } else if(WheelPos < 170) {
    WheelPos -= 85;
   return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  } else {
   WheelPos -= 170;
   return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  }
}
